﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using MinecraftInfoLib;

namespace MinecraftChatClient
{
    public partial class FormChat : Form
    {

        private ChatClient client;
        private IPAddress ipAddress;
        private int port;
        private string username;
        private string password;

        public string Username
        {
            get { return username; }
            set { username = value; }
        }

        public string Password
        {
            get { return password; }
            set { password = value; }
        }

        public IPAddress IPAddress
        {
            get { return ipAddress; }
            set { ipAddress = value; }
        }

        public int Port
        {
            get { return port; }
            set { port = value; }
        }

        public FormChat()
        {
            InitializeComponent();
        }

        public void Start()
        {
            var auth = new Authentificator();
            auth.Username = Username;
            auth.Password = Password;
            var info = auth.Login();

            client = new ChatClient(ipAddress, (ushort)port);
            client.AuthInfo = info;
            client.LoggedIn += client_LoggedIn;
            client.ChatMessage += client_ChatMessage;
            client.Connect();
        }

        private void FormChat_Load(object sender, EventArgs e)
        {

        }

        private void client_LoggedIn(object sender, LoggedInEventArgs e)
        {
            AppendLine("Logged in ...");
            AppendLine(String.Format("Entity ID: {0}\nDimension: {1}\nDifficulty: {2}\nLevel Type: {3}\nMax Players: {4}\nServer Mode: {5}",
                e.LoginInfo.EntityId,
                e.LoginInfo.Dimension,
                e.LoginInfo.Difficulty,
                e.LoginInfo.LevelType,
                e.LoginInfo.MaxPlayers,
                e.LoginInfo.ServerMode));
        }

        private void client_ChatMessage(object sender, ChatMessageEventArgs e)
        {
            AppendLine(e.Message);
        }

        private void AppendLine(string line_)
        {
            if (rtbChat.InvokeRequired)
            {
                rtbChat.Invoke((Action)(() => rtbChat.AppendText(line_ + "\n")));
            }
            else
            {
                rtbChat.AppendText(line_ + "\n");
            }
        }

        private void rtbChat_TextChanged(object sender, EventArgs e)
        {

        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            client.SendChatMessage(tbxMessage.Text);
        }
    }
}
