﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MinecraftInfoLib
{
    internal static class EndianHelper
    {

        /// <summary>
        /// Converts byte order to big endian if needed.
        /// </summary>
        /// <param name="data_">Byte array that is to be converted.</param>
        /// <returns>If the system's byte order is little endian, data_ reversed, otherwise data_.</returns>
        /// <remarks>This method will only work properly if data_'s source is this system.</remarks>
        public static byte[] ReverseIfNeeded(byte[] data_)
        {
            if (BitConverter.IsLittleEndian)
            {
                return data_.Reverse().ToArray();
            }
            else
            {
                return data_;
            }
        }

        /*/// <summary>
        /// See explanation of "ToJava".
        /// </summary>
        /// <param name="data_"></param>
        /// <returns></returns>
        public static byte[] FromJava(byte[] data_)
        {
            if (BitConverter.IsLittleEndian)
            {
                return data_.Reverse().ToArray();
            }
            else
            {
                return data_;
            }
        }*/

    }
}
