﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace MinecraftInfoLib
{
    internal class PacketDefragger
    {

        private MemoryStream buffer;

        public PacketDefragger()
        {
            buffer = new MemoryStream();
        }

        public IPacket Feed(byte[] data_)
        {
            buffer.Write(data_, 0, data_.Length);
            return null;
        }

    }

    internal class PacketInfo
    {

        private byte id;
        private DataType[] types;

        public byte Id
        {
            get { return id; }
            set { id = value; }
        }

        public DataType[] Types
        {
            get { return types; }
            set { types = value; }
        }

        public PacketInfo()
        {

        }

        public PacketInfo(byte id_, DataType[] types_)
            : this()
        {
            id = id_;
            types = types_;
        }

        public enum DataType
        {
            Byte,   // 1 byte
            Short,  // 2 bytes
            Int,    // 4 bytes
            Long,   // 8 bytes
            Float,  // 4 bytes
            Double, // 8 bytes

            String  // 2+x bytes
        }

    }
}
