﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerInfoTest
{
    class Program
    {
        static MinecraftInfoLib.ServerInfoRetriever retriever;

        static void Main(string[] args)
        {

            Console.WriteLine("Little endian: " + BitConverter.IsLittleEndian);

            Console.WriteLine("Select:");
            Console.WriteLine("0: ServerInfoRetriever");
            Console.WriteLine("1: Authentificator");
            Console.WriteLine("2: ChatClient");

            int option = Int32.Parse(Console.ReadLine());

            if (option == 0)
            {
                Console.Write("IP: ");
                string ip = Console.ReadLine();
                Console.WriteLine();

                retriever = new MinecraftInfoLib.ServerInfoRetriever(ip);
                retriever.BeginFetch(Callback, null);

                Console.WriteLine("Ima wait.");
                System.Threading.Thread.Sleep(10000);
                Console.WriteLine("Done waiting. :3");

                Console.ReadLine();
            }
            else if (option == 1)
            {
                Console.Write("Username: ");
                string username = Console.ReadLine();
                Console.Write("Password: ");
                string password = Console.ReadLine();

                MinecraftInfoLib.Authentificator auth = new MinecraftInfoLib.Authentificator(username, password);
                Console.WriteLine(auth.Login());

                Console.ReadLine();
            }
            else if (option == 2)
            {
                Console.Write("IP: ");
                string ip = Console.ReadLine();
                Console.Write("Username: ");
                string username = Console.ReadLine();
                Console.Write("Password: ");
                string password = Console.ReadLine();

                var client = new MinecraftInfoLib.ChatClient(ip);
                client.LoggedIn += client_LoggedIn;
                var auth = new MinecraftInfoLib.Authentificator(username, password);

                Console.WriteLine("Authentificating ...");
                client.AuthInfo = auth.Login();

                Console.WriteLine("Logging in ...");
                client.Connect();
            }

            for (; ; ) ;

        }

        static void Callback(IAsyncResult result_)
        {
            MinecraftInfoLib.ServerInfo info = retriever.EndFetch(result_);
            Console.WriteLine("Description: " + info.Description);
            Console.WriteLine("Players:     " + info.PlayerCount);
            Console.WriteLine("Max Players: " + info.MaxPlayerCount);
        }

        static void client_LoggedIn(object sender, EventArgs e)
        {
            Action chatLoop = ChatLoop;
            chatLoop.BeginInvoke(chatLoop_Callback, chatLoop);
        }

        static void ChatLoop()
        {
            
        }

        static void chatLoop_Callback(IAsyncResult result_)
        {
            Action chatLoop = (Action)result_.AsyncState;
            chatLoop.EndInvoke(result_);
        }
    }
}
